#! /bin/bash
#author：yuansx
#date：2020-08-12

#参数1：安装包绝对路（带阅读器安装文件名称）
#参数2：阅读器包名
#参数3：包类型deb/rpm
#参数4：升级完成提示信息url地址

#example:
#./AutoUpdate.sh '/home/suwell/Desktop/0811/2cn.suwell.deb' 'suwellreaderpro' 'deb'
#./AutoUpdate.sh '/root/桌面/0803/suwellreaderpro-3.0.20.0803-1.mips64.rpm' 'suwellreaderpro' 'rpm'

PACK_DIR=$1
PACK_NAME=$2
PACK_DEB_RPM=$3
PACK_URL=$4

g_autoupdate_log='/tmp/autoupdate.log'

echo 'start AutoUpdate .................' >> "${g_autoupdate_log}"
echo '============= params list ====================' >> "${g_autoupdate_log}"
echo 'PACK_DIR:' $PACK_DIR >> "${g_autoupdate_log}"
echo 'PACK_NAME:' $PACK_NAME >> "${g_autoupdate_log}"
echo 'PACK_DEB_RPM:' $PACK_DEB_RPM >> "${g_autoupdate_log}"
echo 'PACK_URL:' $PACK_URL >> "${g_autoupdate_log}"
echo '==============================================' >> "${g_autoupdate_log}"

#备份用户目录下配置文件至tmp目录下
sw_backup_config_for_user()
{
	P_PARM=$1	
	echo "backup P_PARM is:${P_PARM}" >> "${g_autoupdate_log}"
	
	if [ "${P_PARM}" == "CPBAK" ]; then
		s_tmp_sw_uppack="/tmp/suwellreaderbackups/rootuser"
		if [ -d "${s_tmp_sw_uppack}" ]; then
			sudo rm -rf "${s_tmp_sw_uppack}"
		fi
		sudo mkdir -p "${s_tmp_sw_uppack}"
		sudo chmod -R 777 "${s_tmp_sw_uppack}"

		s_root_readerconfig_ini="/root/.config/suwellreader/readerconfig.ini"
		s_root_update_json="/root/.config/suwellreader/update.json"
		s_root_update_ini="/root/.config/suwellreader/update.ini"
		
		if [ -f "${s_root_readerconfig_ini}" ]; then
            sudo cp -f "${s_root_readerconfig_ini}" "${s_tmp_sw_uppack}"
            sudo chmod -R 777 "${s_tmp_sw_uppack}/readerconfig.ini"
		fi

		if [ -f "${s_root_update_json}" ]; then
            sudo cp -f "${s_root_update_json}" "${s_tmp_sw_uppack}"
            sudo chmod -R 777 "${s_tmp_sw_uppack}/update.json"
		fi

		if [ -f "${s_root_update_ini}"  ]; then
            sudo cp -f "${s_root_update_ini}" "${s_tmp_sw_uppack}"
            sudo chmod -R 777 "${s_tmp_sw_uppack}/update.ini"
		fi
				
		for FILENAME in /home/*; do		
			s_tmp_common_uppack="/tmp/suwellreaderbackups/${FILENAME}/"			
			if [ -d "${s_tmp_common_uppack}" ]; then
				sudo rm -rf "${s_tmp_common_uppack}"
			fi
			sudo mkdir -p "${s_tmp_common_uppack}"
			sudo chmod -R 777 "${s_tmp_common_uppack}"
		
			s_common_readerconfig_ini="${FILENAME}/.config/suwellreader/readerconfig.ini"
			s_common_update_json="${FILENAME}/.config/suwellreader/update.json"
			s_common_update_ini="${FILENAME}/.config/suwellreader/update.ini"
			
			if [ -f "${s_common_readerconfig_ini}" ]; then
                sudo cp -f "${s_common_readerconfig_ini}" "${s_tmp_common_uppack}"
                sudo chmod -R 777 "${s_tmp_common_uppack}/readerconfig.ini"
			fi
			
			if [ -f "${s_common_update_json}" ]; then
                sudo cp -f "${s_common_update_json}" "${s_tmp_common_uppack}"
                sudo chmod -R 777 "${s_tmp_common_uppack}/update.json"
			fi
			
			if [ -f "${s_common_update_ini}" ]; then
                sudo cp -f "${s_common_update_ini}" "${s_tmp_common_uppack}"			
                sudo chmod -R 777 "${s_tmp_common_uppack}/update.ini"
			fi
		done	
	fi
}

#恢复旧配置至用户目录下
sw_recovery_config_for_user()
{
	P_PARM=$1	
	echo "recovery P_PARM is:${P_PARM}" >> "${g_autoupdate_log}"
	
	#if [ "${P_PARM}" == "CPTOOPT" ]; then	
	if [ "${P_PARM}" == "CPTOOPT" ] && [ -f "${s_updatepackinfo_ini}" ]; then
		s_tmp_sw_uppack="/tmp/suwellreaderbackups/rootuser"
		s_configs_dir="/root/.config/suwellreader"

		if [ ! -d "${s_configs_dir}" ]; then
			sudo mkdir -p "${s_configs_dir}"			
		fi
		if [ -f "${s_tmp_sw_uppack}/readerconfig.ini" ]; then		
			sudo cp -f "${s_tmp_sw_uppack}/readerconfig.ini" "${s_configs_dir}"
		fi		
		if [ -f "${s_tmp_sw_uppack}/update.json" ]; then
			sudo cp -f "${s_tmp_sw_uppack}/update.json" "${s_configs_dir}"
		fi
		if [ -f "${s_tmp_sw_uppack}/update.ini" ]; then
			sudo cp -f "${s_tmp_sw_uppack}/update.ini" "${s_configs_dir}"
		fi
		
		for FILENAME in /home/*; do
			if id -u `echo ${FILENAME} | awk '{print substr($FILENAME, 7, 32)}'` >/dev/null 2>&1; then
				:
			else
				continue
			fi		
		
			s_tmp_common_src_bakcup_dir="/tmp/suwellreaderbackups/${FILENAME}/"
			s_tmp_common_usre_dir="${FILENAME}/.config/suwellreader"
			if [ ! -d "${s_tmp_common_usre_dir}" ]; then
				sudo mkdir -p "${s_tmp_common_usre_dir}"			
			fi		
			if [ -f "${s_tmp_common_src_bakcup_dir}/readerconfig.ini" ]; then
				sudo cp -f "${s_tmp_common_src_bakcup_dir}/readerconfig.ini" "${s_tmp_common_usre_dir}"
			fi
			if [ -f "${s_tmp_common_src_bakcup_dir}/update.json" ]; then
				sudo cp -f "${s_tmp_common_src_bakcup_dir}/update.json" "${s_tmp_common_usre_dir}"
			fi
			if [ -f "${s_tmp_common_src_bakcup_dir}/update.ini" ]; then
				sudo cp -f "${s_tmp_common_src_bakcup_dir}/update.ini" "${s_tmp_common_usre_dir}"
			fi
			sudo chmod -R 777 "${s_tmp_common_usre_dir}"			
			local curUserName=`echo ${FILENAME} | awk '{print substr($FILENAME, 7, 32)}'`
			echo 'curUserName: ' $curUserName >> "${g_autoupdate_log}"
			sudo chown ${curUserName}:${curUserName} -R "${s_tmp_common_usre_dir}"	
		done		
	fi	
}

sw_clean_config_for_user()
{
	if [ "${P_PARM}" == "CLEANTMP" ]; then
		s_tmp_sw_uppack="/tmp/suwellreaderbackups"
		sudo rm -rf "${s_tmp_sw_uppack}"
	fi
}

copy_bk_sw_config(){
	P_PARM=$1
	
	echo "P_PARM is:${P_PARM}" >> "${g_autoupdate_log}"
	# >/dev/null 2>&1

	s_readerconfig_ini="/opt/suwell/Reader_Pro/configs/readerconfig.ini"
	s_update_json="/opt/suwell/Reader_Pro/configs/update.json"
	s_update_ini="/opt/suwell/Reader_Pro/configs/update.ini"

	s_updatepackinfo_ini="/opt/suwell/Reader_Pro/configs/updatepackinfo.ini"
	s_configs_dir="/opt/suwell/Reader_Pro/configs"
	s_tmp_sw_uppack="/tmp/suwellreaderbackups/instdir"
		
	if [ "${P_PARM}" == "CPBAK" ]; then
		if [ -d "${s_tmp_sw_uppack}" ]; then
			sudo rm -rf "${s_tmp_sw_uppack}"
		fi
		sudo mkdir -p "${s_tmp_sw_uppack}"
		sudo chmod -R 777 "${s_tmp_sw_uppack}"
		
		if [ -f "${s_readerconfig_ini}" ]; then
            sudo cp -f "${s_readerconfig_ini}" "${s_tmp_sw_uppack}"
		fi		
		if [ -f "${s_update_json}" ]; then
			sudo cp -f "${s_update_json}" "${s_tmp_sw_uppack}"
		fi
		if [ -f "${s_update_ini}" ]; then
			sudo cp -f "${s_update_ini}" "${s_tmp_sw_uppack}"
		fi
	fi
	
	#if [ "${P_PARM}" == "CPTOOPT" ] && [ -d "${s_tmp_sw_uppack}" ] && [ -d "${s_configs_dir}" ]; then
	if [ "${P_PARM}" == "CPTOOPT" ] && [ -d "${s_tmp_sw_uppack}" ] && [ -d "${s_configs_dir}" ] && [ -f "${s_updatepackinfo_ini}" ]; then    
		if [ -f "${s_tmp_sw_uppack}/update.json" ]; then
            sudo cp -f "${s_tmp_sw_uppack}/update.json" "${s_configs_dir}"
            sudo chmod 777 "${s_configs_dir}/update.json"
		fi		
		if [ -f "${s_tmp_sw_uppack}/readerconfig.ini" ]; then
            sudo cp -f "${s_tmp_sw_uppack}/readerconfig.ini" "${s_configs_dir}"
            sudo chmod 777 "${s_configs_dir}/readerconfig.ini"
		fi
		if [ -f "${s_tmp_sw_uppack}/update.ini" ]; then
            sudo cp -f "${s_tmp_sw_uppack}/update.ini" "${s_configs_dir}"
            sudo chmod 777 "${s_configs_dir}/update.ini"
		fi
	fi
	
	if [ "${P_PARM}" == "CLEANTMP" ]; then
		sudo rm -rf "${s_tmp_sw_uppack}"
	fi
}

#deb
update_for_deb(){
	P_PATH=$1
	P_NAME=$2	
	x=`dpkg -l | grep $P_NAME`
	if [ `dpkg -l | grep $P_NAME |wc -l` -ne 0 ];then
		echo -e "the packet_list: \n$x"
		sudo dpkg -r ${P_NAME} >> "${g_autoupdate_log}"
	else
		echo "no install $P_NAME"
	fi
	
	if [ -d "/opt/suwell/Reader_Pro" ]; then
		sudo rm -rf "/opt/suwell/Reader_Pro"
	fi	
	if [ -d "/opt/app/cn.suwell.reader" ]; then
		sudo rm -rf "/opt/app/cn.suwell.reader"
	fi	
	
	echo '============= update suwellreader ============' >> "${g_autoupdate_log}"
	echo 'start update install suwell reader...' >> "${g_autoupdate_log}"
	sudo dpkg -i $P_PATH >> "${g_autoupdate_log}"
	echo '==============================================' >> "${g_autoupdate_log}"
	echo 'update_for_deb finished ...' >> "${g_autoupdate_log}"
}

#rpm
update_for_rpm(){
	P_PATH=$1
	P_NAME=$2
	if rpm -q $P_NAME &>/dev/null; then
		echo "${P_NAME} is already installed." >> "${g_autoupdate_log}"
		echo "start sudo rpm -e --nodeps ${P_NAME}" >> "${g_autoupdate_log}"
		sudo rpm -e --nodeps ${P_NAME} >> "${g_autoupdate_log}"
	else
		echo "${P_NAME} is not installed!"
	fi
	echo '============= update suwellreader ============' >> "${g_autoupdate_log}"
	echo 'start update install suwell reader...' >> "${g_autoupdate_log}"
	sudo rpm -ivh $P_PATH --nodeps --force >> "${g_autoupdate_log}"
	echo '============= update suwellreader ============' >> "${g_autoupdate_log}"
	echo 'update_for_rpm finished ...' >> "${g_autoupdate_log}"
}

function sw_main()
{
	echo 'start sw_main ...' >> "${g_autoupdate_log}"

	process=$(ps -e | grep -iw SuwellReader | cut -b -5)
	if [ -n "$process" ]; then    
		killall -9 suwellreader
	fi

	if [ -f "/tmp/suwellreader/setup.ini" ]; then
		sudo rm -rf "/tmp/suwellreader/setup.ini"
	fi

	#backup ini
	copy_bk_sw_config "CPBAK"
	sw_backup_config_for_user "CPBAK"
	
	#deb
	if [ "$PACK_DEB_RPM" == "deb" ];then
		update_for_deb ${PACK_DIR} ${PACK_NAME}
	fi

	#rpm
	if [ "$PACK_DEB_RPM" == "rpm" ];then
		update_for_rpm ${PACK_DIR} ${PACK_NAME}
	fi

	#copt to ini installdir
	copy_bk_sw_config "CPTOOPT"
	sw_recovery_config_for_user "CPTOOPT"
	
	#clean temp dir
	copy_bk_sw_config "CLEANTMP"	
	sw_clean_config_for_user "CLEANTMP"
	
	#write flag
	if [ -f "/tmp/suwellreader/setup.ini" ]; then
		sudo rm -rf "/tmp/suwellreader/setup.ini"
	fi
	
	#echo "setupstatus=1" >> '/tmp/suwellreader/setup.ini'
	#echo "[setup]" >> '/tmp/suwellreader/setup.ini'
	#echo "setupstatus=1" >> '/tmp/suwellreader/setup.ini'

	echo "start open url is:${PACK_URL}" >> "${g_autoupdate_log}"
	if [ -n "$PACK_URL" ]; then		
		#browser_file=$(which uos-browser)
		#if [ -n "$browser_file" ]; then
		#	echo "uos-browser..."
		#	uos-browser ${PACK_URL}
		#else
		#	browser_file=$(which firefox)
		#	if [ -n "$browser_file" ]; then
		#		echo "firefox..."
		#		firefox ${PACK_URL}
		#	fi
		#fi	
		
		if which xdg-open > /dev/null
		then
		  echo "start xdg-open..."
		  #nohup xdg-open $PACK_URL >/dev/null 2>&1	
		  #nohup xdg-open $PACK_URL "/tmp/suwellreader_output.log" 2>&1 
		  sudo nohup /usr/bin/xdg-open $PACK_URL &  >> "${g_autoupdate_log}"
		elif which gnome-open > /dev/null
		then
		  echo "start gnome-open ..." >> "${g_autoupdate_log}"
		  gnome-open $PACK_URL >> "${g_autoupdate_log}"
		fi
	fi
	echo 'finished ...' >> "${g_autoupdate_log}"
	echo '' >> "${g_autoupdate_log}"	
	exit 0
}

sw_main $@


#function sw_test()
#{	
	#copy_bk_sw_config "CPBAK"
	#sw_backup_config_for_user "CPBAK"

	#copy_bk_sw_config "CPTOOPT"
	#sw_recovery_config_for_user "CPTOOPT"

	#copy_bk_sw_config "CLEANTMP"	
	#sw_clean_config_for_user "CLEANTMP"
#}

#sw_test $@
